#pragma once
#include "UndoableValue.h"
#include "RedoableValue.h"

template<typename valueType>
struct UndoRedoValue : UndoableValue<valueType>, RedoableValue<valueType>
{
	UndoRedoValue(valueType startingValue)
	{
		this->value = startingValue;
	}

	void setValue(valueType value)
	{
		this->updateUndoableValue(this->value, value);
		this->value = value;
		this->updateRedoableValue(this->value, value);
	}

	void redoSet()
	{
		this->RedoableValue<valueType>::redoSet(this->value);
	}

	void undoSet()
	{
		this->UndoableValue<valueType>::undoSet(this->value);
	}

	valueType value;
};
