#include <vector>
#include <string>
#include "Location2D.h"

template<typename vectorType>
bool inVector(const std::vector<vectorType>& haystack, const vectorType& needle)
{
	return std::find(haystack.begin(), haystack.end(), needle) != haystack.end();
}

template<typename vectorType>
void getLimits(const std::vector<vectorType>& haystack, vectorType& min, vectorType& max)
{
	min = std::numeric_limits<vectorType>::max();
	max = std::numeric_limits<vectorType>::min();
	for(const vectorType needle : haystack)
	{
		if(needle < min)
		{
			min = needle;
		}
		if(needle > max)
		{
			max = needle;
		}
	}
}

int main()
{
	std::vector<int> vector;
	vector.push_back(-1);
	vector.push_back(1);
	vector.push_back(3);
	vector.push_back(8);

	bool test1 = inVector(vector, 1);
	bool test2 = inVector(vector, 2);

	printf((std::string("inVector test 1: ") + std::to_string(test1)).c_str());
	printf((std::string("inVector test 2: ") + std::to_string(test2)).c_str());

	// ==============

	int min;
	int max;
	getLimits(vector, min, max);

	printf((std::string("getLimits min: ") + std::to_string(min)).c_str());
	printf((std::string("getLimits max: ") + std::to_string(max)).c_str());

	// ==============

	// TODO: Add test for Pair.

	// ==============

	{
		Location2D<int> location = Location2D<int>(10, 20);

		location.print();
		location.y.setValue(10);
		location.print();
		location.y.undoSet();
		location.print();
		location.y.redoSet();
		location.print();
	}

	// ==============

	while(true) {}

	return 0;
}
